//	----------------------------------------------------------------------------------------------------------------
//	SUS޲plibusbٿĳ IIC-Ex
//	
//	2020.05.06	M.YOSHIDA
//	
//	RasberryPI ZeroWHɂ͓mF
//	
//	SUS_I2c_ReadEx()ySUS_I2c_WriteEx()̻
//	SUS_I2c_ReadEx()ySUS_I2c_WriteEx()ׂ͌݊̈ɗp
//	VKĳɂ SUS_I2c_ReadEx2()/SUS_I2c_WriteEx2 gpĉB
//	
//	----------------------------------------------------------------------------------------------------------------
#include	<unistd.h>
#include	<stdlib.h>
#include	<stdio.h>
#include	<string.h>
#include	<sys/stat.h>
#include	<time.h>
#include	<stdbool.h>
#include	</usr/include/usb.h>
#include	"SUS.h"


#define		IIC_DEV_ADRS	0xA0		//	for 24LC01

int		main( int argc, char **argv	)
{
	int						i, j, port;
	int						pid = 0;
	int						find = 0;
	unsigned short			id;

	struct					usb_bus *busses;
	struct					usb_bus	*bus;
	struct					usb_device	*dev;
	struct					usb_device	*target_dev;
	usb_dev_handle			*handle;

	unsigned char			rd;
	unsigned char			wd[128];
	unsigned char			dump[128];

	printf("\nSUSIIC_ExTest Version 1.00          Copyright(C) 2004-2020, Prime Systems, Inc.\n");
	printf("Smart-USB Sigma Series\n");
	printf("Build time %s %s\n", __DATE__, __TIME__ );
	printf("\nexample) ./SUSI2c_ExTest [-p8005]\n");
	printf("-p ... Target ProductID.(optional)\n");


	//	Ұ擾
	for(i=0;i<argc;++i)
	{
		sscanf( argv[i], "-p%x", &pid  );
	}

	//	libusb̏
	usb_init();

	//	USB޽̌&XV
	usb_find_busses();

	//	USB޲̌&XV
	usb_find_devices();

	//	USBνĐ̎擾
	busses = usb_get_busses();

	//	Smart-USB޲̌
	//	PSIАID޲
	//	ްނڑĂŌ1݂̂gp
	printf("\nChecking ... USB Devices.\n\n");
	for(bus=busses;bus;bus=bus->next)
	{
		for(dev=bus->devices;dev;dev=dev->next)
		{
			if( dev->descriptor.idVendor )
			{
				printf("%04X:%04X", dev->descriptor.idVendor, dev->descriptor.idProduct );
				if( dev->descriptor.idVendor == PSI_VENDOR_ID )
				{
					if( pid )
					{
						if( dev->descriptor.idProduct == pid )
						{
							target_dev = dev;
							find = 1;
							printf("    <- Smart-USB Sigma ... Device Find!!\n");
						}
						else
						{
							printf("\n");
						}
					}
					else
					{
						target_dev = dev;
						find = 1;
						printf("    <- Smart-USB Sigma ... Device Find!!\n");
					}
				}
				else
				{
					printf("\n");
				}
			}
		}
	}


	//	ޯ޲̊mF
	//	ޯĂȂΉɏI
	if( find == 0 )
	{
		printf("\nSmart-USB Sigma ... Device not found!!\n" );
		return	false;
	}

	//	USB޲̵
	handle = usb_open( target_dev );
	if( !handle )
	{
		printf("Smart-USB Sigma Device Open Error!!\n\n");
		return false;
	}

	
	if( usb_set_configuration( handle, target_dev->config->bConfigurationValue ))
	{
		printf("SET_Config ERROR!!\n");
		usb_close( handle );
		return	false;
	}

	//	USB̪̲̪ݒ
	if( usb_claim_interface( handle, target_dev->config->interface->altsetting->bInterfaceNumber )<0)
	{
		printf("usb_claim_interface Error!!(%s)\n\n", usb_strerror());
		usb_close( handle );
		return	false;
	}

	//	݂޲ްޏ\
	printf("\n");
	if( !VIEW_BoardInfo( handle ))
	{
		printf("VIEW_BoardInfo() ERROR!!\n");
		usb_close( handle );
		return	false;
	}

	//	-----------------------------------------------------------------------
	//	SUS_I2c_ReadEx()ySUS_I2c_WriteEx() s
	//	-----------------------------------------------------------------------
	for(port=0;port<2;++port)
	{
		//	ްײ
		srand(( unsigned int )time( NULL ));
		printf("Port%d I2C Writing ........ ", port);
		for(i=0;i<128;++i)
		{
			wd[i] = rand() % 256;
			if( !SUS_I2c_WriteEx( handle, port, IIC_DEV_ADRS, i, wd[i] ))
			{
				printf("Failed to SUS_I2c_WriteEx() on Port%d.\n\n", port );
				usb_close( handle );
				return	false;
			}
			//	EEPROMײđҋ@(5ms)
			usleep( 5000 );
		}
		printf(" I2C Write OK!!\n");

		//	ذޏ
		for(i=0;i<128;++i)
		{
			if( !SUS_I2c_ReadEx( handle, port, IIC_DEV_ADRS, i, &rd ))
			{
				printf("Failed to SUS_I2c_ReadEx()on Port%d.\n\n", port );
				usb_close( handle );
				return	false;
			}
			else
			{
				dump[i] = rd;
			}
		}
		printf("Port%d I2C Read OK!!\n", port );

		//	̧
		for(i=0;i<128;++i)
		{
			if( dump[i] != wd[i] )
			{
				printf("Port%d I2C Verify  Failed!!\n", port );
				usb_close( handle );
				return false;
			}
		}
		printf("Port%d I2C Verify OK!!\n\n", port );

		//	ߕ\
		printf("Port%d I2C DUMP:\n", port );
		printf("ADRS 00 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F\n");
		for(i=0;i<8;++i)
		{
			printf("%04X ", i*16 );
			for(j=0;j<16;++j)
			{
				printf("%02X ", dump[i*16+j]);
			}
			printf("\n");
		}
		printf("\n");
	}

	usb_close( handle );
	return	true;
}
